// cvedll.h - CABS Viewer Engine DLL header file
//
//  Copyright (c) 2003-2005 Lymeware Corporation,  All Rights Reserved
//  THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF LYMEWARE CORPORATION
//     The copyright notice above does not evidence any actual or
//     intended publication of such source code.
// 
// $Header: /projRCS/cabsviewer/cvengine/cvedll.h,v 1.1 2006/09/06 21:27:49 kobar Exp $
// Additional Engine DLL functions for CABS Viewer
//

#ifndef CVE_DLL_H
#define CVE_DLL_H 1

#if CPP == 1
   #define EXPORT extern "C" __declspec(dllimport)
#else
   #ifdef BUILD_DLL
      // the dll exports
      #define EXPORT __declspec(dllexport)
   #else
      // the exe imports
      #define EXPORT __declspec(dllimport)
   #endif
#endif
//#define EXPORT

// CVE types for DLL function calls ------------------------------------
//

typedef struct options_tag {
	// configuration globals =======================================
	//     externally set (config file, command line switches, etc)
	//      in switch ascii order
	int output_format;
	// output format values ========================================
#define FORMAT_TEXT	0		/* -t --text */
#define FORMAT_CSV	1		/* -c --csv */
#define FORMAT_HTML	2		/* -w --html */
#define FORMAT_XML	3		/* -x --xml */

	int display_bill;	        /* -1 --billrecords */
	int display_detail;	        /* -3 --detailrecords */
	int display_csr;	        /* -4 --csrrecords */
					/* -a -A UNUSED */
	int bodyonly_flag;	        /* -b --bodyonly */
					/* -B    UNUSED */
					/* -c --csv */
	int print_common;		/* -C --common */
	int debug_flag;			/* -d --debug */
	int database_flag;		/* -D --database */
					/* -e -E UNUSED */
					/* -f -F UNUSED */
					/* -g -G UNUSED */
					/* -h -H UNUSED */
					/* -i -I UNUSED */
					/* -j -J UNUSED */
					/* -k -K UNUSED */
					/* -l -L UNUSED */
					/* -m -M UNUSED */
	int print_recno;		/* -n --recno */
	int numeric_flag;		/* -N --number */
					/* -o FILE --output=FILE */
					/* -O    UNUSED */
					/* -p -P UNUSED */
	int print_header;		/* -q --noheader */
					/* -Q    UNUSED */
	int print_raw;			/* -r --raw */
					/* -R    UNUSED */
	int print_summary;		/* -s --summary */
	int print_summarydetail;	/* -S --summarydetail */
					/* -t --text */
	int print_types;		/* -T --types */
	int uppercase_flag;		/* -u --uppercase */
					/* -U    UNUSED */
					/* -w --html */
					/* -W    UNUSED */
					/* -x --xml */
					/* -X    UNUSED */
					/* -y -Y UNUSED */
	int print_trailer;		/* -z --notrailer */
					/* -Z    UNUSED */
} options_t;

// function to be imported/exported
// pre-1.6 functions for backwards compatibility - DO NOT USE for NEW CODE
EXPORT int cvengine(char *infilename, char *outfilename, options_t *options);
EXPORT int init_options(options_t *options);
EXPORT int dump_options(options_t *options);

// NEW 1.6 functions
EXPORT int cve_process_file(char *infilename, char *outfilename, options_t *options);
EXPORT int cve_process_buf(unsigned char *inbuf, unsigned int insize, 
		unsigned char *outbuf, unsigned int outsize, 
		options_t *options, void *config);
EXPORT unsigned int cve_estimate_buf(unsigned int insize, options_t *options);
EXPORT int cve_init_options(options_t *options);
EXPORT int cve_dump_options(options_t *options);
#endif /* ifdef CVE_DLL_H */
// EOF
#ident "$Header: /projRCS/cabsviewer/cvengine/cvedll.h,v 1.1 2006/09/06 21:27:49 kobar Exp $"
